.TH decoding_rng 3

==NAME==

decoding_rng - Base rings for decoding

==DESCRIPTION==

A ring *R* is usually a set of functions and a C structure contained in
one header file and which implements arithmetic operations and
elements manipulation of a ring or field. Mandatory functions are:

===void init(a)===

Initialize the memory needed for the element *a* of *R*.

===void clear(a)===

Free the memory used by *a*.

===void copy(a,b)===

Make a deep copy of *b* into *a*.

===void print(FILE \*out,a)===

Write (or prettyprint) *a* into *out*.

===int cmp(a,b)===

Return *0* if and only if *a* is equal to *b*.

===void zero(a)===

Set *a* to the zero element of *R*.

===int iszero(a)===

Return *0* if *a* is the zero element of *R*.

===void random(a)===

Pick up a random element *b* of *R* and store it into *a*.

===void castint(a,int n)===

Cast the *n* (integer of type int) into *R* and store the result in
*a*.

===void add(a,b,c)===

Store *b* + *c* into *a*.

===void neg(a,b,c)===

Store -*b* into *a*.

===void sub(a,b,c)===

Store *b* - *c* into *a*.

===void mul(a,b,c)===

Store *b* x *c* into *a*.

===int inv(a,b)===

If the inverse of *b* exists in *R* then store the inverse of *b* into
*a* and return *0*. Otherwise return *-1*.

===int div(a,b,c)===

If the inverse of *c* exists in *R* then store *b* multiplied by the
inverse of *c* into *a* and return *0*. Otherwise return *-1*.

==AUTHOR==

Written by Guillaume Quintin (coincoin169@gmail.com).

