/*
 * This file is part of decoding.
 * Copyright (C) 2012  Guillaume Quintin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

/* ARITHMETIC */

void ll_array_add(R *r,R *a,int na,R *b,int nb) {
  int i;
  if ( na < nb ) {
    for( i = 0 ; i < na ; i++ ) {
      R_add(r[i],a[i],b[i]);
    }
    ll_vec_copy(&r[na],&b[na],nb - na);
  }
  else {
    for( i = 0 ; i < nb ; i++ ) {
      R_add(r[i],a[i],b[i]);
    }
    ll_vec_copy(&r[nb],&a[nb],na - nb);
  }
}

void ll_array_add_mul_by_cte(R *r,int nr,R *a,int na,R b) {
  int i;
  if ( nr < na ) {
    for( i = 0 ; i < nr ; i++ ) {
      R_add_mul(r[i],a[i],b);
    }
    for( i = nr ; i < na ; i++ ) {
      R_mul(r[i],a[i],b);
    }
  }
  else {
    for( i = 0 ; i < na ; i++ ) {
      R_add_mul(r[i],a[i],b);
    }
  }
}

