/*
 * This file is part of decoding.
 * Copyright (C) 2012  Guillaume Quintin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

void ll_dbpol_print_factorized(FILE *out,R *a,int nax,int nay) {
  int i;
  for( i = 0 ; i < nay && ll_vec_iszero(&a[i * nax],nax) ; i++ );
  if ( i >= nay ) {
    fputc('0',out);
    return;
  }
  fputc('(',out);
  ll_upol_print(out,&a[i * nax],nax);
  fputc(')',out);
  if ( i == 1 ) fputs(" * Y",out);
  if ( i > 1 ) fprintf(out," * Y^%d",i);
  for( i++ ; i < nay ; i++ ) {
    if ( !ll_vec_iszero(&a[i * nax],nax) ) {
      fputs(" + (",out);
      ll_upol_print(out,&a[i * nax],nax);
      fputc(')',out);
      if ( i == 1 ) fputs(" * Y",out);
      if ( i > 1 ) fprintf(out," * Y^%d",i);
    }
  }
}

