/*
 * This file is part of decoding.
 * Copyright (C) 2012  Guillaume Quintin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

void ll_mat_copy(R *r,R *a,int ar,int ac) {
  ll_vec_copy(r,a,ar * ac);
}

R *ll_mat_malloc(int mr,int mc) {
  return ll_vec_malloc(mr * mc);
}

R *ll_mat_malloc_zero(int mr,int mc) {
  return ll_vec_malloc_zero(mr * mc);
}

R *ll_mat_malloc_random(int mr,int mc) {
  return ll_vec_malloc_random(mr * mc);
}

void ll_mat_free(R *m,int mr,int mc) {
  ll_vec_free(m,mr * mc);
}

void ll_mat_transpose(R *r,R *a,int ar,int ac) {
  int i,j,k,na;
  R *tmp;
  na = ar * ac;
  if ( a == r ) {
    tmp = ll_vec_malloc_copy(a,na);
  }
  else {
    tmp = a;
  }
  for( i = 0,j = 0,k = 0 ; i < na ; i++,j += ar ) {
    if ( j >= na ) {
      k++;
      j = k;
    }
    R_copy(r[j],tmp[i]);
  }
}

