/*
 * This file is part of decoding.
 * Copyright (C) 2012  Guillaume Quintin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

void ll_upol_normalize(R *r,int nr) {
  R inv;
  int i;

  R_init(inv);
  if ( R_inv(inv,r[nr - 1]) ) {
    ll_die("leading coefficient not invertible\n"
           "cannot normalize");
  }
  for( i = 0 ; i < nr ; i++ ) {
    R_mul(r[i],r[i],inv);
  }
  R_clear(inv);
}

