/*
 * This file is part of decoding.
 * Copyright (C) 2012  Guillaume Quintin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

void ll_upol_shift_naive(R *r,R *a,int na,R b) {
  int i,j;
  R_copy(r[0],a[na - 1]);
  for( i = na - 2,j = 1 ; i >= 0 ; i--,j++ ) {
    ll_upol_mul_by_affine(r,r,j,b);
    R_add(r[0],r[0],a[i]);
  }
}

void ll_upol_shift(R *r,R *a,int na,R b) {
#ifdef MY_UPOL_SHIFT
  MY_UPOL_SHIFT(r,a,na,b);
#else
#ifdef RING_COMM_CAR2
  ll_upol_shift_car2(r,a,na,b);
#else
  ll_upol_shift_fast(r,a,na,b);
#endif
#endif
}

